/*
 * mathutilities.h 
 *
 * Some mathematical functions.
 *
 * Copyright (C) 1995, Christoph Streit <streit@iam.unibe.ch>
 *                     Stephan Amann <amann@iam.unibe.ch>
 *                     University of Berne, Switzerland
 * Copyright (C) 1999, Thierry Matthey <matthey@ii.uib.no>
 *
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
 */

#include "mathutilities.h"
// #include "fortrancall.h"

// #ifdef __cplusplus
// extern "C" {
// #endif
//   extern double fgauss_(INTP dummy);
//   extern double fpower_(DBLP x, INTP n);
// #ifdef __cplusplus
// } /* extern "C" */
// #endif

static Real gauss_table[]={3.949846138,0.0,0.252408784,0.0,0.076542912,0.0, 0.008355968,0.0, 0.029899776};
//_______________________________________________________________ power

Real power(Real x, long n)
{
  // Simple an fast way to compute the int-power
  Real z=1;
  long  m=n;
  Real y=x;

  while(m>0){
    if(m&1)
      z *=y;

    y*=y;
    m >>=1;

  }
  return z;

}

// //_______________________________________________________________ fpower


// double fpower(double x, int n)
// {
//   return fpower_(&x,&n);
// }

// //_______________________________________________________________ gauss

Real gauss()
{
  Real r =0.0;
  for(long i=0;i<12;i++)
    r += myrandom();
  r = (r -6.0)/4.0;
  Real r2 = r*r;

  return (((( gauss_table[8] * r2 + gauss_table[6] ) * r2 + gauss_table[4] ) * r2 + gauss_table[2] ) * r2 +gauss_table[0] )* r;
}





